routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\CompanieController;
use App\Http\Controllers\EmployeeController;
use App\Http\Controllers\Auth\SocialiteController;


/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/


Auth::routes([
    'register' => false
]);

Route::get('/auth/redirect/{provider}',[SocialiteController::class,'redirect'])->name('auth.redirect');
Route::get('/auth/callback/{provider}',[SocialiteController::class,'callback'])->name('auth.callback');

Route::middleware('auth')->group(function(){
    
    Route::get('lang/{lang}', ['as' => 'lang.switch', 'uses' => App\Http\Controllers\LanguageController::class,'switch']);

    Route::get('/', function () {
        return view('home');
    });

    Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

    Route::resource('employees',EmployeeController::class)->except(['destroy']);
    Route::get('/employees/{employee}/destroy',[EmployeeController::class,'destroy'])->name('employees.destroy');
    
    Route::resource('companies',CompanieController::class)->except(['destroy']);
    Route::get('/companies/{company}/destroy',[CompanieController::class,'destroy'])->name('companies.destroy');
    
});

app/Models/Companie.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Companie extends Model
{
    use HasFactory;

    protected $fillable = [
        'name',
        'email',
        'logo',
        'website'
    ];

    public function employees(){
        return $this->hasMany(Employee::class);
    }
}

app/Http/Controllers/CompanieController.php
<?php

namespace App\Http\Controllers;

use Spatie\Image\Image;
use App\Models\Companie;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Storage;
use App\Http\Requests\CompanieStoreRequest;

class CompanieController extends Controller
{
    public $logoName;

    public function resize_logo($logo){

        $this->logoName = time() . '.' . $logo->extension();
        $path = $logo->storeAs('public/logos',$this->logoName);

        //resize logo with spatie
        Image::load(public_path('storage/logos') . '/' . $this->logoName)->width(100)->height(100)->save();
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        // $companies = Companie::latest()->paginate(10);
        // return view('companie.index',compact('companies'));
        return view('companie.index');
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('companie.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(CompanieStoreRequest $request)
    {
        //store logo
        if($request->hasFile('logo')){
            $logo = $request->file('logo');
            //resize logo function
            $this->resize_logo($logo);
        }else{
            $this->logoName = 'default.jpg';
        }
        
        Companie::create([
            'name' => $request->name,
            'email' => $request->email,
            'logo' => $this->logoName,
            'website' => $request->website
        ]);

        return redirect()->route('companies.create')->with('message',['text' => __('companie.status2'), 'class' => 'success']);
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit(Companie $company)
    {
        return view('companie.edit',compact('company'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(CompanieStoreRequest $request, Companie $company)
    {
        //store logo
        if($request->hasFile('logo')){
            $logo = $request->file('logo');
            //resize image function
            $this->resize_logo($logo);
        }else if($company->logo != null){
            $this->logoName = $company->logo;
        }else{
            $this->logoName = 'default.jpg';
        }

        $company->update([
            'name' => $request->name,
            'email' => $request->email,
            'logo' => $this->logoName,
            'website' => $request->website
        ]);

        return redirect()->route('companies.edit',$company->id)->with('message',['text' => __('companie.status3'), 'class' => 'success']);

    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy(Companie $company)
    {
        $company->delete();
        return redirect()->route('companies.index')->with('message',['text' => __('companie.status4'), 'class' => 'success']);
    }
}

app/View/Components/Companies.php
<?php

namespace App\View\Components;

use App\Models\Companie;
use Illuminate\View\Component;


class Companies extends Component
{
    /**
     * Create a new component instance.
     *
     * @return void
     */
    public function __construct()
    {
        //
    }

    /**
     * Get the view / contents that represent the component.
     *
     * @return \Illuminate\Contracts\View\View|\Closure|string
     */
    public function render()
    {
        $companies = Companie::count();
        return view('components.companies',compact('companies'));
    }
}

resources/views/companie/create.blade.php
@extends('layouts.app')
@section('title')
{{ __('companie.title2') }}
@endsection
@section('content')
<div class="container">
    <div class="row justify-content-center">

      @include('layouts.notif')

        <div class="col-md-12 mt-2">
            <div class="card">
                <div class="card-header">
                    {{ __('companie.title2') }}
                    <a href="{{ route('companies.index') }}" class="btn btn-sm btn-secondary float-right">{{ __('companie.btn4') }}</a>
                </div>
                <div class="card-body">
                    <form action="{{ route('companies.store') }}" method="POST" enctype="multipart/form-data">
                        @csrf
                        <div class="row">
                          <div class="col-6">
                            <label for="">{{ __('companie.table1') }}</label>
                            <input type="text" class="form-control" name="name" value="{{ old('name') }}">
                            @include('layouts.error', ['name' => 'name'])
                          </div>
                          <div class="col-6">
                            <label for="">{{ __('companie.table2') }}</label>
                            <input type="email" class="form-control" name="email" value="{{ old('email') }}">
                            @include('layouts.error', ['name' => 'email'])
                        </div>
                      </div>
                      <div class="row mt-3">
                            <div class="col-6">
                                <img id="output" src="" width="100" height="100" alt="Logo Preview" class="img-thumbnail">
                                <div class="custom-file mt-3">
                                    <input type="file" name="logo" class="custom-file-input" accept="image/*" onchange="document.getElementById('output').src = window.URL.createObjectURL(this.files[0])">
                                    @include('layouts.error', ['name' => 'logo'])
                                    <label for="" class="custom-file-label">{{ __('companie.table3') }}</label>
                                </div>
                            </div>
                            <div class="col-6 ">
                                <label for="">{{ __('companie.table4') }}</label>
                                <div class="mt-2">
                                    <input type="text" name="website" class="form-control" value="{{ old('website') }}">
                                    @include('layouts.error', ['name' => 'website'])
                                </div>
                            </div>
                      </div>
                      <div class="row p-3">
                            <button class="btn btn-primary btn-block" type="submit">{{ __('companie.btn1') }}</button>
                      </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/companie/edit.blade.php
@extends('layouts.app')
@section('title')
{{ __('companie.title3') }}
@endsection
@section('content')
<div class="container">
    <div class="row justify-content-center">

      @include('layouts.notif')

        <div class="col-md-12 mt-2">
            <div class="card">
                <div class="card-header">
                    {{ __('companie.title3') }}
                    <a href="{{ route('companies.index') }}" class="btn btn-sm btn-secondary float-right"> {{ __('companie.btn4') }}</a>
                </div>
                <div class="card-body">
                    <form action="{{ route('companies.update',$company->id) }}" method="POST" enctype="multipart/form-data">
                        @csrf
                        @method('PUT')
                        <div class="row">
                          <div class="col-6">
                            <label for=""> {{ __('companie.table1') }}</label>
                            <input type="text" class="form-control" name="name" value="{{ $company->name }}">
                            @include('layouts.error', ['name' => 'name'])
                          </div>
                          <div class="col-6">
                            <label for=""> {{ __('companie.table2') }}</label>
                            <input type="email" class="form-control" name="email" value="{{ $company->email }}">
                            @include('layouts.error', ['name' => 'email'])
                        </div>
                      </div>
                      <div class="row mt-3">
                            <div class="col-6">
                                <img id="output" src="{{ Storage::url('logos/' . $company->logo) }}" width="100" height="100" alt="Logo Preview" class="img-thumbnail">
                                <div class="custom-file mt-3">
                                    <input type="file" name="logo" class="custom-file-input" accept="image/*" onchange="document.getElementById('output').src = window.URL.createObjectURL(this.files[0])">
                                    @include('layouts.error', ['name' => 'logo'])
                                    <label for="" class="custom-file-label"> {{ __('companie.table3') }}</label>
                                </div>
                            </div>
                            <div class="col-6 ">
                                <label for=""> {{ __('companie.table4') }}</label>
                                <div class="mt-2">
                                    <input type="text" name="website" class="form-control" value="{{ $company->website }}">
                                    @include('layouts.error', ['name' => 'website'])
                                </div>
                            </div>
                      </div>
                      <div class="row p-3">
                            <button class="btn btn-primary btn-block" type="submit"> {{ __('companie.btn5') }}</button>
                      </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/companie/index.blade.php
@extends('layouts.app')
@section('title')
{{ __('companie.title1') }}
@endsection
@section('content')
<div class="container">
    <div class="row justify-content-center">

        @include('layouts.notif')

        <div class="col-md-12 mt-2">
            <div class="card">
                <div class="card-header">
                    {{ __('companie.title1') }}
                    <a href="{{ route('companies.create') }}" class="btn btn-sm btn-primary float-right">{{ __('companie.btn1') }}</a>
                </div>
                <div class="card-body">
                    <table class="table text-center table-bordered table-striped" id="CompaniesTable">
                        <thead>
                            <tr>
                                <th>#</th>
                                <th>{{ __('companie.table1') }}</th>
                                <th>{{ __('companie.table2') }}</th>
                                <th>{{ __('companie.table3') }}</th>
                                <th>{{ __('companie.table4') }}</th>
                                <th>{{ __('companie.table5') }}</th>
                            </tr>
                        </thead>
                        <tbody>
                        </tbody>
                    </table>
                </div>
            </div>
        </div>

       

    </div>
</div>
@endsection
@section('script')
<script type="text/javascript">
    $(document).ready( function () {
        $.noConflict();
        $('#CompaniesTable').DataTable({
            "processing": true,
            "serverSide": true,
            "responsive": true,
            "ajax": "{{ route('api.companies') }}",
            "columns": [
                { "data": "DT_RowIndex", name:'DT_RowIndex'},
                { "data": "name" },
                { "data": "email" },
                { "data": "image", name:'image', orderable: false, searchable: false },
                { "data": "website" },
                { "data": "action", name:'action', orderable: false, searchable: false }
            ]
        });

    } );
</script>
@endsection